import { FirebaseApp } from '@nativescript/firebase-core';
import { IMessaging, RemoteMessage } from '.';
import { AuthorizationStatus } from '@nativescript/firebase-messaging-core';
export { AuthorizationStatus };
export declare class Messaging implements IMessaging {
    #private;
    showNotificationsWhenInForeground: boolean;
    constructor();
    getToken(): Promise<string>;
    getAPNSToken(): any;
    hasPermission(): Promise<AuthorizationStatus>;
    onMessage(listener: (message: RemoteMessage) => any): void;
    onNotificationTap(listener: (message: RemoteMessage) => any): void;
    onToken(listener: (token: string) => any): void;
    registerDeviceForRemoteMessages(): Promise<void>;
    requestPermission(permissions?: any): Promise<AuthorizationStatus>;
    subscribeToTopic(topic: string): Promise<void>;
    unregisterDeviceForRemoteMessages(): Promise<void>;
    unsubscribeFromTopic(topic: string): Promise<void>;
    deleteToken(): Promise<void>;
    get isDeviceRegisteredForRemoteMessages(): boolean;
    get autoInitEnabled(): boolean;
    set autoInitEnabled(value: boolean);
    get app(): FirebaseApp;
    get native(): com.google.firebase.messaging.FirebaseMessaging;
    get android(): com.google.firebase.messaging.FirebaseMessaging;
}
