var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _Messaging_app, _Messaging_onMessage, _Messaging_onToken, _Messaging_onNotificationTap, _Messaging_instance;
import { firebase, FirebaseApp, FirebaseError } from '@nativescript/firebase-core';
import { MessagingCore, AuthorizationStatus } from '@nativescript/firebase-messaging-core';
export { AuthorizationStatus };
let _registerDeviceForRemoteMessages = {
    resolve: null,
    reject: null,
};
let defaultMessaging;
const fb = firebase();
Object.defineProperty(fb, 'messaging', {
    value: () => {
        if (!defaultMessaging) {
            defaultMessaging = new Messaging();
        }
        return defaultMessaging;
    },
    writable: false,
});
export class Messaging {
    constructor() {
        _Messaging_app.set(this, void 0);
        _Messaging_onMessage.set(this, void 0);
        _Messaging_onToken.set(this, void 0);
        _Messaging_onNotificationTap.set(this, void 0);
        _Messaging_instance.set(this, void 0);
        if (defaultMessaging) {
            return defaultMessaging;
        }
        defaultMessaging = this;
        __classPrivateFieldSet(this, _Messaging_instance, MessagingCore.getInstance(), "f");
    }
    get showNotificationsWhenInForeground() {
        return NSCFirebaseMessagingCore.showNotificationsWhenInForeground;
    }
    set showNotificationsWhenInForeground(value) {
        NSCFirebaseMessagingCore.showNotificationsWhenInForeground = value;
    }
    get _onMessage() {
        return __classPrivateFieldGet(this, _Messaging_onMessage, "f");
    }
    get _onNotificationTap() {
        return __classPrivateFieldGet(this, _Messaging_onNotificationTap, "f");
    }
    get _onToken() {
        return __classPrivateFieldGet(this, _Messaging_onToken, "f");
    }
    getToken() {
        return new Promise((resolve, reject) => {
            var _a;
            if (!TNSFirebaseCore.isSimulator() && !UIApplication.sharedApplication.registeredForRemoteNotifications) {
                reject(new Error('You must be registered for remote messages before calling getToken, see messaging().registerDeviceForRemoteMessages()'));
                return;
            }
            (_a = this.native) === null || _a === void 0 ? void 0 : _a.tokenWithCompletion((token, error) => {
                if (error) {
                    reject(FirebaseError.fromNative(error));
                }
                else {
                    resolve(token);
                }
            });
        });
    }
    getAPNSToken() {
        return NSCFirebaseMessagingCore.APNSTokenToString(this.native.APNSToken);
    }
    hasPermission() {
        return __classPrivateFieldGet(this, _Messaging_instance, "f").hasPermission();
    }
    onMessage(listener) {
        if (!listener && __classPrivateFieldGet(this, _Messaging_onMessage, "f")) {
            __classPrivateFieldGet(this, _Messaging_instance, "f").removeOnMessage(__classPrivateFieldGet(this, _Messaging_onMessage, "f"));
        }
        else {
            __classPrivateFieldGet(this, _Messaging_instance, "f").addOnMessage(listener);
        }
        __classPrivateFieldSet(this, _Messaging_onMessage, listener, "f");
    }
    onToken(listener) {
        if (!listener && __classPrivateFieldGet(this, _Messaging_onToken, "f")) {
            __classPrivateFieldGet(this, _Messaging_instance, "f").removeOnToken(__classPrivateFieldGet(this, _Messaging_onToken, "f"));
        }
        else {
            __classPrivateFieldGet(this, _Messaging_instance, "f").addOnToken(listener);
        }
        __classPrivateFieldSet(this, _Messaging_onToken, listener, "f");
    }
    onNotificationTap(listener) {
        if (!listener && __classPrivateFieldGet(this, _Messaging_onNotificationTap, "f")) {
            __classPrivateFieldGet(this, _Messaging_instance, "f").removeOnNotificationTap(__classPrivateFieldGet(this, _Messaging_onNotificationTap, "f"));
        }
        else {
            __classPrivateFieldGet(this, _Messaging_instance, "f").addOnNotificationTap(listener);
        }
        __classPrivateFieldSet(this, _Messaging_onNotificationTap, listener, "f");
    }
    registerDeviceForRemoteMessages() {
        return __classPrivateFieldGet(this, _Messaging_instance, "f").registerDeviceForRemoteMessages();
    }
    requestPermission(permissions) {
        return __classPrivateFieldGet(this, _Messaging_instance, "f").requestPermission(permissions);
    }
    subscribeToTopic(topic) {
        return new Promise((resolve, reject) => {
            this.native.subscribeToTopicCompletion(topic, (error) => {
                if (error) {
                    reject(FirebaseError.fromNative(error));
                }
                else {
                    resolve();
                }
            });
        });
    }
    unregisterDeviceForRemoteMessages() {
        return __classPrivateFieldGet(this, _Messaging_instance, "f").unregisterDeviceForRemoteMessages();
    }
    unsubscribeFromTopic(topic) {
        return new Promise((resolve, reject) => {
            this.native.unsubscribeFromTopicCompletion(topic, (error) => {
                if (error) {
                    reject(FirebaseError.fromNative(error));
                }
                else {
                    resolve();
                }
            });
        });
    }
    deleteToken() {
        return new Promise((resolve, reject) => {
            var _a;
            (_a = this.native) === null || _a === void 0 ? void 0 : _a.deleteDataWithCompletion((error) => {
                if (error) {
                    reject(FirebaseError.fromNative(error));
                }
                else {
                    resolve();
                }
            });
        });
    }
    get isDeviceRegisteredForRemoteMessages() {
        return __classPrivateFieldGet(this, _Messaging_instance, "f").isDeviceRegisteredForRemoteMessages;
    }
    get autoInitEnabled() {
        var _a;
        return (_a = this.native) === null || _a === void 0 ? void 0 : _a.autoInitEnabled;
    }
    set autoInitEnabled(value) {
        this.native.autoInitEnabled = value;
    }
    get app() {
        if (!__classPrivateFieldGet(this, _Messaging_app, "f")) {
            // @ts-ignore
            __classPrivateFieldSet(this, _Messaging_app, FirebaseApp.fromNative(FIRApp.defaultApp()), "f");
        }
        return __classPrivateFieldGet(this, _Messaging_app, "f");
    }
    get native() {
        return FIRMessaging.messaging();
    }
    get ios() {
        return this.native;
    }
}
_Messaging_app = new WeakMap(), _Messaging_onMessage = new WeakMap(), _Messaging_onToken = new WeakMap(), _Messaging_onNotificationTap = new WeakMap(), _Messaging_instance = new WeakMap();
//# sourceMappingURL=index.ios.js.map